
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>




using namespace std;

#define OUTPUTFILENAME		"%%tmp_ipmitool_output"

const int ipmbaddr[] = {0x70, 0x72, 0x74, 0x76, 0x78, 0x7a, 0x7c, 0x7e, 0x80, 0x82, 0x84, 0x86, 0x88, 0xa4};
const char* arglist[] = {"?", "-s", "-t", "in", "out", "clr"};
enum argtype {HELP=0, SLOT, DURATION, INARG, OUTARG, CLRARG, LASTARG};
typedef enum {OVIN, OVOUT, OVCLR} override_t;
char cmdlinebuf[128];


int main(int argc, char** argv) {
  bool fatal = false;
  int slotnum = 0;
  int duration = 0;
  unsigned char retbytes[32];
  int retbytecnt;
  FILE* rfile;
  override_t override = OVCLR;
  

  // parse command line
  int i1 = 1;
  while ((i1<argc) && !fatal) {
    int argidx;
    string curargv = argv[i1];
    for (argidx=0; argidx<LASTARG; argidx++) {
      if (curargv == arglist[argidx]) {
        // have match
        uint tempui;
        switch (argidx) {
          case HELP:
            cout << "command line arguments:\n";
            cout << "  ? - display this text\n";
            cout << "   -s <slot#> - MicroTCA slot number (1-13)\n";
            cout << "   -t <time> - Optional override time in seconds to max of 25 seconds\n";
            cout << "  in|out|clr\n";
            exit(0);
          case SLOT:
            i1++;
            if (i1 >= argc) {
              cerr << "?error missing slot number argument on command line\n";
              fatal = true;
            }
            else {
              sscanf(argv[i1], "%i", &slotnum);
            }            
            break;

          case DURATION:
            i1++;
            if (i1 >= argc) {
              cerr << "?error missing duration argument on command line\n";
              fatal = true;
            }
            else {
              sscanf(argv[i1], "%i", &duration);
              if ((duration < 0) || (duration > 25)) {
                cerr << "?error invalid duration value\n";
                fatal = true;
              }
            }            
            break;

          case INARG:
            override = OVIN;
            break;

          case OUTARG:
            override = OVOUT;
            break;

          case CLRARG:
            override = OVCLR;
            break;

          default:
            cerr << "?fatal error while parsing command line--try running command again with '?' argument\n";
            fatal = true;
            break;
        }
        break;
      }
    }
    if (argidx>=LASTARG) {
      cerr << "?error, unknown argument '" << curargv << "'\n";    
      fatal = true;
      break;
    }
    i1++;
  }
  
  if ((slotnum < 1) || (slotnum >13)) {
    cerr << "?error invalid slot number (" << slotnum << ")\n";
    fatal = true;
  }

  if (fatal)
    // stop now, before things go too far
    exit(0);

  // issue override command
  if (override == OVCLR) {
    sprintf(cmdlinebuf, "ipmitool $IPMITOOLARGS -t 0x%02x raw 0x32 0x0f 0x00>%s\n", ipmbaddr[slotnum], OUTPUTFILENAME);
  }
  else {
    if (override == OVIN)
      sprintf(cmdlinebuf, "ipmitool $IPMITOOLARGS -t 0x%02x raw 0x32 0x0f 0x80 0x%02x >%s\n", ipmbaddr[slotnum], duration*10, OUTPUTFILENAME);
    else
      sprintf(cmdlinebuf, "ipmitool $IPMITOOLARGS -t 0x%02x raw 0x32 0x0f 0x81 0x%02x >%s\n", ipmbaddr[slotnum], duration*10, OUTPUTFILENAME);
  }
  system(cmdlinebuf);

  return 1;

}

