
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string>
#include <iostream>
#include <sstream>
#include <fstream>




using namespace std;

#define OUTPUTFILENAME		"%%tmp_ipmitool_output"

const int ipmbaddr[] = {0x70, 0x72, 0x74, 0x76, 0x78, 0x7a, 0x7c, 0x7e, 0x80, 0x82, 0x84, 0x86, 0x88, 0xa4};
const char* arglist[] = {"?", "-s"};
enum argtype {HELP=0, SLOT, LASTARG};
char cmdlinebuf[128];


int main(int argc, char** argv) {
  bool fatal = false;
  int slotnum = 0;
  unsigned long uptime;
  unsigned long hottime;
  unsigned long days, hours, mins, secs;
  time_t mmc_systime;
  unsigned char retbytes[32];
  int retbytecnt;
  FILE* rfile;
  

  // parse command line
  int i1 = 1;
  while ((i1<argc) && !fatal) {
    int argidx;
    string curargv = argv[i1];
    for (argidx=0; argidx<LASTARG; argidx++) {
      if (curargv == arglist[argidx]) {
        // have match
        uint tempui;
        switch (argidx) {
          case HELP:
            cout << "command line arguments:\n";
            cout << "  ? - display this text\n";
            cout << " -s <slot#> - MicroTCA slot number (1-13)\n";
            fatal = true;
            break;
          case SLOT:
            i1++;
            if (i1 >= argc) {
              cerr << "?error missing slot number argument on command line\n";
              fatal = true;
            }
            else { 
              sscanf(argv[i1], "%i", &slotnum);
            }
            break;
          default:
            cerr << "?fatal error while parsing command line--try running command again with '?' argument\n";
            fatal = true;
            break;
        }
        break;
      }
    }
    if (argidx>=LASTARG) {
      cerr << "?error, unknown argument '" << curargv << "'\n";    
      fatal = true;
      break;
    }
    i1++;
  }
  
  if ((slotnum < 1) || (slotnum >13)) {
    cerr << "?error invalid slot number (" << slotnum << ")\n";
    fatal = true;
  }

  if (fatal)
    // stop now, before things go too far
    exit(0);

  // get system time
  mmc_systime = time(NULL); 
  retbytes[0] = mmc_systime & 0xff;
  mmc_systime = mmc_systime >> 8;
  retbytes[1] = mmc_systime & 0xff;
  mmc_systime = mmc_systime >> 8;
  retbytes[2] = mmc_systime & 0xff;
  mmc_systime = mmc_systime >> 8;
  retbytes[3] = mmc_systime & 0xff;



  // get up time and hot time values
  // execute IPMI tool on bash command line
  sprintf(cmdlinebuf, "ipmitool $IPMITOOLARGS -t 0x%02x raw 0x32 0x29 0x%02x 0x%02x 0x%02x 0x%02x >%s\n", ipmbaddr[slotnum], 
    retbytes[0], retbytes[1], retbytes[2], retbytes[3], OUTPUTFILENAME);
  system(cmdlinebuf);

  return 1;
}
